#include <stdio.h>
#include <string.h>

#ifdef __linux__
#include <bsd/stdlib.h>
#else
#include <stdlib.h>
#endif

#include "advent2015.h"
#include "advent2016.h"
#include "advent2017.h"
#include "advent2018.h"
#include "advent2019.h"
#include "advent2020.h"
#include "advent2021.h"
#include "advent2022.h"
#include "advent2023.h"

int main(int argc, char **argv) {
    if (argc != 3) {
        printf("Usage: advent $YEAR $DAY\nExample: advent 15 1 will run Solution Day 01 of 2015\n\n");
        return 1;
    }

    int day = 0, year = 0;
    char buf[32];
    const char *errstr = NULL;

    year = strtonum(argv[1], 15, 23, &errstr);
    if (NULL != errstr) {
        printf("Input error: %s\n\n", errstr);
        return 1;
    }

    day = strtonum(argv[2], 1, 25, &errstr);
    if (NULL != errstr) {
        printf("Input error: %s\n\n", errstr);
        return 1;
    }

    switch (year) {
    case 15:
        solutions2015[day - 1]();
        break;
    case 16:
        solutions2016[day - 1]();
        break;
    case 17:
        solutions2017[day - 1]();
        break;
    case 18:
        solutions2018[day - 1]();
        break;
    case 19:
        solutions2019[day - 1]();
        break;
    case 20:
        solutions2020[day - 1]();
        break;
    case 21:
        solutions2021[day - 1]();
        break;
    case 22:
        solutions2022[day - 1]();
        break;
    case 23:
        solutions2023[day - 1]();
        break;
    }

    return 0;
}
